DECLARE FUNCTION getarg$ (argsnum%, a$)
CLS
PRINT getarg$(0, COMMAND$)            ' get the first command line argument

FUNCTION getarg$ (argnum%, a$)

  '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  ' this function returns command line arguments.
  ' for example to get the first command line argument you would do this..
 
  '           PRINT getarg$(1,COMMAND$)

  ' if argnum% = 0 then it passes back the number of command line arguments
  ' that were in the string (as a string)                             
  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  
  IF LEN(a$) < 1 AND argnum% = 0 THEN
     getargs$ = STR$(VAL("0"))          ' guard against illegal function call error
     EXIT FUNCTION
  END IF
 
  IF LEN(a$) < 1 AND argnum% <> 0 THEN
     getargs$ = ""          ' guard against illegal function call error
     EXIT FUNCTION
  END IF
  
  g$ = RTRIM$(a$)
  g$ = g$ + " "

  nextarg% = 0
  tcounter% = 0
  isinquotes% = 0
  CONSECUTIVE% = 0
 
 FOR q% = 1 TO LEN(g$)
   char$ = MID$(g$, q%, 1)                 ' get each character

   SELECT CASE char$
     CASE CHR$(34):
              IF isinquotes% = 0 THEN       ' got the first "
               isinquotes% = 1
               commandline$ = commandline$ + char$
               CONSECUTIVE% = 0
              ELSEIF isinquotes% = 1 THEN   ' got a closing "
               isinquotes% = 0
               commandline$ = commandline$ + char$
               CONSECUTIVE% = 0
              END IF
   
     CASE " ":
              IF isinquotes% = 0 AND CONSECUTIVE% = 0 THEN       ' got a space not in quotes
               nextarg% = nextarg% + 1          ' got an argument
               IF nextarg% = argnum% THEN
                 getarg$ = commandline$       ' this is the one we wanted
                 EXIT FUNCTION
               ELSE
                 commandline$ = ""            ' this is one we didn't want
               END IF
             
               CONSECUTIVE% = 1
              ELSEIF isinquotes% = 0 AND CONSECUTIVE% = 1 THEN
               ' do nothing
              ELSEIF isinquotes% = 1 THEN
              commandline$ = commandline$ + char$
              END IF
   
     CASE CHR$(9):
              IF isinquotes% = 1 THEN
              commandline$ = commandline$ + char$
              CONSECUTIVE% = 0
              END IF
             
     CASE ELSE:
              commandline$ = commandline$ + char$
              CONSECUTIVE% = 0
   END SELECT
 NEXT q%

 IF argnum% = 0 THEN
   getarg$ = STR$(nextarg%)
   EXIT FUNCTION
 END IF

 getarg$ = ""

END FUNCTION

